## lomiri-system-settings 1.3.1

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5)

project(lomiri-system-settings VERSION 1.3.1 LANGUAGES C CXX)

if(${PROJECT_BINARY_DIR} STREQUAL ${PROJECT_SOURCE_DIR})
   message(FATAL_ERROR "In-tree build attempt detected, aborting. Set your build dir outside your source dir, delete CMakeCache.txt from source root and try again.")
endif()

string(TOLOWER "${CMAKE_BUILD_TYPE}" cmake_build_type_lower) # Build types should always be lowercase but sometimes they are not.

set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${CMAKE_CURRENT_SOURCE_DIR}/cmake)
include(EnableCoverageReport)
include(FindPkgConfig)
include(GNUInstallDirs)
set(LIBDIR ${CMAKE_INSTALL_LIBDIR})
enable_testing()

option(ENABLE_TESTS "Build tests" ON)
option(ENABLE_LIBDEVICEINFO "Build with libdeviceinfo support" OFF)
option(ENABLE_UBUNTU_ACCOUNTSSERVICE "Build with Ubuntu's fork of accountsservice" OFF)
# TODO: drop this with migration to jammy and beyond!
option(MODERN_PYTHON_DBUSMOCK "Adapt tst-bluetooth-device to work with python-dbusmock 0.26+" ON)

if(cmake_build_type_lower MATCHES coverage)
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} --coverage" )
  set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} --coverage" )
  set(CMAKE_MODULE_LINKER_FLAGS "${CMAKE_MODULE_LINKER_FLAGS} --coverage" )
  set(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} --coverage" )

  # We add -g when building with coverage so valgrind reports line numbers.
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -g" )
  set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -g" )
endif()

set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fno-permissive -pedantic -Wall -Wextra")
find_package(Qt5Concurrent REQUIRED)
find_package(Qt5Core REQUIRED)
find_package(Qt5DBus REQUIRED)
find_package(Qt5Gui REQUIRED)
find_package(Qt5Network REQUIRED)
find_package(Qt5Qml REQUIRED)
find_package(Qt5Quick REQUIRED)
find_package(Qt5Sql REQUIRED)
find_package(Qt5Test REQUIRED)
find_package(Qt5Widgets REQUIRED)

# Workaround for https://bugreports.qt-project.org/browse/QTBUG-29987
set(QT_IMPORTS_DIR "${CMAKE_INSTALL_LIBDIR}/qt5/qml")
set(CMAKE_AUTOMOC ON)

pkg_search_module(GOBJECT REQUIRED gobject-2.0)
pkg_search_module(GLIB REQUIRED glib-2.0)
pkg_check_modules(GIO REQUIRED gio-2.0 gio-unix-2.0)
pkg_check_modules(LIBSYSTEMD REQUIRED libsystemd)
pkg_check_modules(POLKIT_AGENT REQUIRED polkit-agent-1)
pkg_check_modules(TRUST_STORE REQUIRED trust-store)
pkg_search_module(UPOWER_GLIB REQUIRED upower-glib)
pkg_search_module(ACCOUNTSSERVICE REQUIRED accountsservice)
if (ENABLE_UBUNTU_ACCOUNTSSERVICE)
    add_compile_definitions(ENABLE_UBUNTU_ACCOUNTSSERVICE)
endif ()
pkg_search_module(GEONAMES REQUIRED geonames)
pkg_search_module(ICU REQUIRED icu-i18n)
pkg_search_module(ANDR_PROP libandroid-properties)
pkg_search_module(CLICK REQUIRED click-0.4)
pkg_check_modules(QTGSETTINGS REQUIRED gsettings-qt)
if(ENABLE_LIBDEVICEINFO)
    pkg_check_modules(DEVICEINFO REQUIRED deviceinfo)
endif()

include(JoinPaths)

# <datadir>: E.g. "share", "/usr/share" "/not/regular/prefix/share"
set(DATA_DIR "${CMAKE_INSTALL_DATADIR}")
set(MODULE_DIR lomiri-system-settings)
set(MANIFEST_DIR lomiri-system-settings)
set(QML_DIR qml-plugins)
set(PRIVATE_DIR private)

# <datadir>/lomiri-system-settings
set(PLUGIN_MANIFEST_DIR_BASE "${DATA_DIR}/${MANIFEST_DIR}")
# lomiri-system-settings
set(PLUGIN_MODULE_DIR_BASE ${MODULE_DIR})
# lomiri-system-settings/private
set(PLUGIN_PRIVATE_MODULE_DIR_BASE "${PLUGIN_MODULE_DIR_BASE}/${PRIVATE_DIR}")
# <datadir>/lomiri-system-settings/qml-plugins
set(PLUGIN_QML_DIR_BASE "${DATA_DIR}/${MANIFEST_DIR}/${QML_DIR}")
# E.g. /usr/share/lomiri-system-settings
join_paths(PLUGIN_MANIFEST_DIR "${CMAKE_INSTALL_PREFIX}" "${PLUGIN_MANIFEST_DIR_BASE}")
# E.g. /usr/lib/lomiri-system-settings
join_paths(PLUGIN_MODULE_DIR "${CMAKE_INSTALL_PREFIX}" "${LIBDIR}/${PLUGIN_MODULE_DIR_BASE}")
# E.g. /usr/share/lomiri-system-settings/qml-plugins
join_paths(PLUGIN_QML_DIR "${CMAKE_INSTALL_PREFIX}" "${PLUGIN_QML_DIR_BASE}")
# E.g. /usr/lib/lomiri-system-settings/private
join_paths(PLUGIN_PRIVATE_MODULE_DIR "${CMAKE_INSTALL_PREFIX}" "${LIBDIR}/${PLUGIN_PRIVATE_MODULE_DIR_BASE}")
join_paths(SETTINGS_SHARE_DIR "${CMAKE_INSTALL_PREFIX}" "${PLUGIN_MANIFEST_DIR_BASE}")

SET(CMAKE_INSTALL_RPATH "${PLUGIN_MODULE_DIR}")

set(DESKTOP_FILE lomiri-system-settings.desktop)
set(GETTEXT_PACKAGE lomiri-system-settings)
set(DESKTOP_FILE ${PROJECT_NAME}.desktop)

add_subdirectory(po)
add_subdirectory(schema)
add_subdirectory(lib)
include_directories(lib)
include_directories(src)
add_subdirectory(plugins)
add_subdirectory(src)
if(ENABLE_TESTS)
  pkg_check_modules(QTDBUSMOCK REQUIRED libqtdbusmock-1 REQUIRED)
  pkg_check_modules(QTDBUSTEST REQUIRED libqtdbustest-1 REQUIRED)
  add_subdirectory(tests)
endif()

include(FindGettext)
configure_file(${DESKTOP_FILE}.in.in ${DESKTOP_FILE}.in)
add_custom_target(${DESKTOP_FILE} ALL
    COMMENT "Merging translations into ${DESKTOP_FILE}..."
    COMMAND ${GETTEXT_MSGFMT_EXECUTABLE}
            --desktop --template=${CMAKE_CURRENT_BINARY_DIR}/${DESKTOP_FILE}.in
            -o ${DESKTOP_FILE}
            -d ${CMAKE_SOURCE_DIR}/po
)

install(FILES ${CMAKE_CURRENT_BINARY_DIR}/${DESKTOP_FILE}
        DESTINATION ${CMAKE_INSTALL_DATADIR}/applications)

install(FILES lomiri-system-settings.url-dispatcher DESTINATION ${CMAKE_INSTALL_DATADIR}/lomiri-url-dispatcher/urls)
install(FILES screenshot.png DESTINATION ${SETTINGS_SHARE_DIR})
install(FILES system-settings.svg DESTINATION ${SETTINGS_SHARE_DIR})
install(FILES system-settings-app-splash.svg DESTINATION ${SETTINGS_SHARE_DIR})

if(cmake_build_type_lower MATCHES coverage)
  ENABLE_COVERAGE_REPORT(TARGETS system-settings FILTER /usr/include ${CMAKE_SOURCE_DIR}/tests/* ${CMAKE_BINARY_DIR}/*)
endif()

=== tests/CMakeLists.txt ===
include_directories(
    ../src
    ${CMAKE_CURRENT_BINARY_DIR}
    ${GLIB_INCLUDE_DIRS}
    ${QTDBUSMOCK_INCLUDE_DIRS}
    ${QTDBUSTEST_INCLUDE_DIRS}
)

set(XVFB_CMD xvfb-run -a -s "-screen 0 640x480x24")

add_definitions(-DI18N_DOMAIN="lomiri-system-settings")
add_definitions(-DPLUGIN_PRIVATE_MODULE_DIR="${PLUGIN_PRIVATE_MODULE_DIR}")
add_definitions(-DPLUGIN_MODULE_DIR="${CMAKE_CURRENT_BINARY_DIR}")
add_definitions(-DMANIFEST_DIR="data")
add_definitions(-DPLUGIN_MANIFEST_DIR="${CMAKE_CURRENT_SOURCE_DIR}/data")
add_definitions(-DQML_TEST_DIR="${CMAKE_CURRENT_SOURCE_DIR}")
add_definitions(-DQML_DIR="${CMAKE_CURRENT_BINARY_DIR}")
add_definitions(-DPLUGIN_QML_DIR="${CMAKE_CURRENT_BINARY_DIR}")
add_definitions(-DSYSTEM_IMAGE_DBUS_TEMPLATE="${CMAKE_SOURCE_DIR}/tests/autopilot/lomiri_system_settings/tests/systemimage.py")

add_library(test-plugin SHARED test-plugin.cpp test-plugin.h)
target_link_librarieS(test-plugin LomiriSystemSettings Qt5::Core Qt5::Qml)

add_library(test-plugin2 SHARED test-plugin2.cpp test-plugin2.h)
target_link_librarieS(test-plugin2 LomiriSystemSettings Qt5::Core Qt5::Qml)

add_executable(tst-plugins
    tst_plugins.cpp
    ../src/debug.cpp
    ../src/item-model.cpp
    ../src/plugin-manager.cpp
    ../src/plugin.cpp
    ../src/debug.h
    ../src/item-model.h
    ../src/plugin-manager.h
    ../src/plugin.h
)

add_executable(tst-arguments
    tst_arguments.cpp
    ../src/utils.cpp
)

target_link_libraries(tst-plugins Qt5::Core Qt5::Qml Qt5::Test LomiriSystemSettings ${GLIB_LDFLAGS})
add_test(tst-plugins tst-plugins)
set_tests_properties(tst-plugins PROPERTIES ENVIRONMENT
    "QT_QPA_PLATFORM=minimal;XDG_DATA_DIRS=${CMAKE_CURRENT_SOURCE_DIR}"
)

target_link_libraries(tst-arguments Qt5::Core Qt5::Test ${GLIB_LDFLAGS})
add_test(tst-arguments tst-arguments)

add_executable(tst-systemimage
    tst_systemimage.cpp
    mocks/system-image-dbus/fakesystemimagedbus.cpp
)
add_test(tst-systemimage tst-systemimage)
target_link_libraries(tst-systemimage
    Qt5::Core Qt5::DBus Qt5::Test
    LomiriSystemSettingsPrivate
    ${QTDBUSMOCK_LIBRARIES}
    ${QTDBUSTEST_LIBRARIES}
)

add_subdirectory(utils)

# QML tests that require graphical capabilities.
add_custom_target(qmluitests)
add_dependencies(qmluitests LomiriSettingsTest)

add_custom_target(qmltests)
add_dependencies(qmltests qmluitests)

add_subdirectory(mocks)
add_subdirectory(plugins)

=== lib/LomiriSystemSettings/CMakeLists.txt ===
add_library(LomiriSystemSettings SHARED item-base.cpp item-base.h)
set_target_properties(LomiriSystemSettings PROPERTIES
VERSION 1.3.1
SOVERSION 1
)

target_link_libraries(LomiriSystemSettings Qt5::Core Qt5::Gui Qt5::Quick Qt5::Qml)

install(TARGETS LomiriSystemSettings LIBRARY DESTINATION ${LIBDIR})
install(FILES item-base.h ItemBase plugin-interface.h PluginInterface
DESTINATION "${CMAKE_INSTALL_INCLUDEDIR}/LomiriSystemSettings")

set(SYSTEMSETTINGS_LIB LomiriSystemSettings)

join_paths(PC_LIBDIR "\${prefix}" "${LIBDIR}")
join_paths(PC_INCLUDEDIR "\${prefix}" "${CMAKE_INSTALL_INCLUDEDIR}")
join_paths(PC_PLUGIN_MANIFEST_DIR "\${prefix}" "${PLUGIN_MANIFEST_DIR_BASE}")
join_paths(PC_PLUGIN_MODULE_DIR "\${libdir}" "${PLUGIN_MODULE_DIR_BASE}")
join_paths(PC_PLUGIN_PRIVATE_MODULE_DIR "\${libdir}" "${PLUGIN_PRIVATE_MODULE_DIR_BASE}")
join_paths(PC_PLUGIN_QML_DIR "\${prefix}" "${PLUGIN_QML_DIR_BASE}")

configure_file(LomiriSystemSettings.pc.in LomiriSystemSettings.pc @ONLY)
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/LomiriSystemSettings.pc DESTINATION ${LIBDIR}/pkgconfig)

=== plugins/about/CMakeLists.txt ===
include_directories(${ANDR_PROP_INCLUDE_DIRS})
include_directories(${DEVICEINFO_INCLUDE_DIRS})
include_directories(${GLIB_INCLUDE_DIRS})
include_directories(${GIO_INCLUDE_DIRS})
include_directories(${CLICK_INCLUDE_DIRS})
include_directories(${CLICK_INCLUDE_DIRS})
add_definitions(-DQT_NO_KEYWORDS)

if(DEVICEINFO_FOUND)
    add_definitions(-DENABLE_DEVICEINFO)
endif()

set(QML_SOURCES
    EntryComponent.qml
    License.qml
    PageComponent.qml
    SingleValueStacked.qml
    Software.qml
    Storage.qml
    StorageBar.qml
    StorageItem.qml
    Version.qml
    DevMode.qml
    fakepkgslist.xml
)

add_library(LomiriStorageAboutPanel MODULE
    plugin.cpp
    storageabout.cpp
    systeminfo.cpp
    click.cpp
    plugin.h
    storageabout.h
    click.h
    ${QML_SOURCES} # So they show up in Qt designer.
)

target_link_libraries(LomiriStorageAboutPanel Qt5::Qml Qt5::Quick Qt5::DBus
${ANDR_PROP_LDFLAGS} ${DEVICEINFO_LDFLAGS} ${GLIB_LDFLAGS} ${GIO_LDFLAGS} ${CLICK_LDFLAGS} LomiriSystemSettingsPrivate)

set(PLUG_DIR ${PLUGIN_PRIVATE_MODULE_DIR}/Lomiri/SystemSettings/StorageAbout)
install(TARGETS LomiriStorageAboutPanel DESTINATION ${PLUG_DIR})
install(FILES qmldir DESTINATION ${PLUG_DIR})
install(FILES ${QML_SOURCES} DESTINATION ${PLUGIN_QML_DIR}/about)
install(FILES settings-about.svg DESTINATION ${PLUGIN_MANIFEST_DIR}/icons)
install(FILES about.settings DESTINATION ${PLUGIN_MANIFEST_DIR})

=== plugins/battery/CMakeLists.txt ===
add_subdirectory(plugin)

add_definitions(-DQT_NO_KEYWORDS)

set(QML_SOURCES
    PageComponent.qml
    SleepValues.qml
)

include_directories(${GLIB_INCLUDE_DIRS} ${UPOWER_GLIB_INCLUDE_DIRS})
add_library(LomiriBatteryPanel MODULE plugin.h battery.h plugin.cpp battery.cpp
${QML_SOURCES})
target_link_libraries(LomiriBatteryPanel Qt5::Quick Qt5::Qml Qt5::DBus ${GLIB_LDFLAGS} ${UPOWER_GLIB_LDFLAGS})

set(PLUG_DIR ${PLUGIN_PRIVATE_MODULE_DIR}/Lomiri/SystemSettings/Battery)
install(TARGETS LomiriBatteryPanel DESTINATION ${PLUG_DIR})
install(FILES qmldir DESTINATION ${PLUG_DIR})
install(FILES ${QML_SOURCES} DESTINATION ${PLUGIN_QML_DIR}/battery)
install(FILES settings-battery.svg DESTINATION ${PLUGIN_MANIFEST_DIR}/icons)
install(FILES battery.settings DESTINATION ${PLUGIN_MANIFEST_DIR})

=== plugins/example/CMakeLists.txt ===
include_directories(${CMAKE_CURRENT_BINARY_DIR})

set(QML_SOURCES PageComponent.qml)
add_library(example-plugin MODULE example-plugin.cpp example-plugin.h ${QML_SOURCES})
target_link_libraries(example-plugin Qt5::Qml Qt5::Core LomiriSystemSettings)

# This plugin is only an example so let's not install it.
#install(FILES example.settings DESTINATION ${PLUGIN_MANIFEST_DIR})
#install(FILES ${QML_SOURCES} DESTINATION ${PLUGIN_QML_DIR}/example)

=== plugins/notifications/CMakeLists.txt ===
add_subdirectory(plugin)

SET (CMAKE_AUTOMOC ON)

set(QML_SOURCES
    PageComponent.qml
    CellBroadcast.qml
    ClickAppNotifications.qml
    ClickAppsSoundsNotify.qml
    ClickAppsVibrationsNotify.qml
    )

set(lomiri_notifications_panel_HDRS
    plugin.h
    general_notification_settings.h
    click_applications_model.h
    click_applications_notify_model.h
    )

set(lomiri_notifications_panel_SRCS
    plugin.cpp
    general_notification_settings.cpp
    click_applications_model.cpp
    click_applications_notify_model.cpp
    )

configure_file(qmldir.in qmldir COPYONLY)
add_library(LomiriNotificationsPanel MODULE ${lomiri_notifications_panel_HDRS} ${lomiri_notifications_panel_SRCS} ${QML_SOURCES})

add_definitions(-DQT_NO_KEYWORDS)
include_directories(${GIO_INCLUDE_DIRS})
include_directories(${QTGSETTINGS_INCLUDE_DIRS})

target_link_libraries(LomiriNotificationsPanel ${GIO_LDFLAGS} ${QTGSETTINGS_LDFLAGS} Qt5::Qml Qt5::Quick)

set(PLUG_DIR ${PLUGIN_PRIVATE_MODULE_DIR}/Lomiri/SystemSettings/Notifications)
install(TARGETS LomiriNotificationsPanel DESTINATION ${PLUG_DIR})
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/qmldir DESTINATION ${PLUG_DIR})
install(FILES ${QML_SOURCES} DESTINATION ${PLUGIN_QML_DIR}/notifications)

install(FILES notifications.settings DESTINATION ${PLUGIN_MANIFEST_DIR})

=== plugins/security-privacy/CMakeLists.txt ===
set(PLUG_DIR ${PLUGIN_PRIVATE_MODULE_DIR}/Lomiri/SystemSettings/SecurityPrivacy)

set(CMAKE_AUTOMOC ON)

set(HELPER_SOURCES
    polkitlistener.cpp
    helper.cpp
)
add_executable(LomiriSecurityPrivacyHelper ${HELPER_SOURCES})

target_include_directories(LomiriSecurityPrivacyHelper PRIVATE
    ${POLKIT_AGENT_INCLUDE_DIRS}
    ${LIBSYSTEMD_INCLUDE_DIRS})
target_compile_definitions(LomiriSecurityPrivacyHelper PRIVATE
    POLKIT_AGENT_I_KNOW_API_IS_SUBJECT_TO_CHANGE)
target_link_libraries(LomiriSecurityPrivacyHelper
    ${POLKIT_AGENT_LDFLAGS}
    ${LIBSYSTEMD_LDFLAGS})

set(QML_SOURCES
    AppAccess.qml
    AppAccessControl.qml
    here-terms.qml
    Location.qml
    LockSecurity.qml
    Ofono.qml
    PageComponent.qml
    PhoneLocking.qml
    PincodePrompts.qml
    SimPin.qml
    sims.js
)
set(PANEL_SOURCES
    connectivity.cpp
    connectivity.h
    plugin.cpp
    plugin.h
    securityprivacy.cpp
    securityprivacy.h
    trust-store-model.cpp
    trust-store-model.h
)
add_library(LomiriSecurityPrivacyPanel MODULE ${PANEL_SOURCES} ${QML_SOURCES})

target_compile_definitions(LomiriSecurityPrivacyPanel PRIVATE
    HELPER_EXEC="${PLUG_DIR}/LomiriSecurityPrivacyHelper"
    QT_NO_KEYWORDS)
target_include_directories(LomiriSecurityPrivacyPanel PRIVATE
    ${Intl_INCLUDE_DIRS}
    ${TRUST_STORE_INCLUDE_DIRS}
    ${GLIB_INCLUDE_DIRS}
)
target_link_libraries (LomiriSecurityPrivacyPanel
    ${Intl_LIBRARIES}
    Qt5::Core
    Qt5::Gui
    Qt5::Qml
    Qt5::Quick
    Qt5::DBus
    LomiriSystemSettingsPrivate
    ${TRUST_STORE_LDFLAGS}
    ${GLIB_LDFLAGS}
)

install(TARGETS LomiriSecurityPrivacyPanel LomiriSecurityPrivacyHelper
    DESTINATION ${PLUG_DIR})
install(FILES qmldir DESTINATION ${PLUG_DIR})
install(FILES ${QML_SOURCES} DESTINATION ${PLUGIN_QML_DIR}/security-privacy)
install(FILES settings-security-privacy.svg
    DESTINATION ${PLUGIN_MANIFEST_DIR}/icons)
install(FILES security-privacy.settings DESTINATION ${PLUGIN_MANIFEST_DIR})

=== plugins/vpn/CMakeLists.txt ===
set(QML_SOURCES
    PageComponent.qml
)

install(FILES vpn.settings DESTINATION ${PLUGIN_MANIFEST_DIR})
install(FILES network-vpn.svg DESTINATION ${PLUGIN_MANIFEST_DIR}/icons)
install(FILES ${QML_SOURCES} DESTINATION ${PLUGIN_QML_DIR}/vpn)

=== tests/mocks/CMakeLists.txt ===
# Set up and optionally install a mock plugin for lomiri-system-setting.
# add_lss_mock(plugin version path)

macro(add_lss_mock PLUGIN VERSION PATH)
    cmake_parse_arguments(MOCK "" "${single}" "" ${ARGN})

    if(NOT QMLFILES_SEARCH_PATH)
        set(QMLFILES_SEARCH_PATH ${CMAKE_CURRENT_SOURCE_DIR})
    endif()

    set(qmlfiles_dir ${CMAKE_CURRENT_BINARY_DIR})

    file(GLOB QMLFILES
        ${QMLFILES_SEARCH_PATH}/*.qml
        ${QMLFILES_SEARCH_PATH}/*.js
        ${QMLFILES_SEARCH_PATH}/*.jpg
        ${QMLFILES_SEARCH_PATH}/*.png
        ${QMLFILES_SEARCH_PATH}/*.sci
        ${QMLFILES_SEARCH_PATH}/*.svg
        ${QMLFILES_SEARCH_PATH}/*.qmltypes
        ${QMLFILES_SEARCH_PATH}/qmldir
    )

    execute_process(COMMAND ${CMAKE_COMMAND} -E make_directory ${qmlfiles_dir})

    # copy the files
    add_custom_target(${QMLFILES_TARGET_PREFIX}${PLUGIN}-qmlfiles ALL
                        COMMAND cp ${QMLFILES} ${qmlfiles_dir}
                        DEPENDS ${QMLFILES}
                        SOURCES ${QMLFILES}
    )
endmacro()

add_subdirectory(GSettings.1.0)
add_subdirectory(Lomiri)
add_subdirectory(QMenuModel)
add_subdirectory(SystemSettings)
add_subdirectory(QOfono)

=== tests/plugins/CMakeLists.txt ===
# add_qml_test macro
include(QmlTest)

add_subdirectory(bluetooth)
add_subdirectory(wifi)
add_subdirectory(notifications)
add_subdirectory(security-privacy)

set(qmltest_DEFAULT_TARGETS qmluitests)
set(qmltest_DEFAULT_PROPERTIES ENVIRONMENT "LC_ALL=C")
set(qmltest_DEFAULT_IMPORT_PATHS
  ${CMAKE_BINARY_DIR}/tests/utils/modules
)

add_qml_test(mouse mouse
             IMPORT_PATHS
             ${CMAKE_BINARY_DIR}/plugins
             ${CMAKE_SOURCE_DIR}/tests/plugins/mouse
             ${qmltest_DEFAULT_IMPORT_PATHS})

add_qml_test(wifi OtherNetwork
             IMPORT_PATHS
             ${CMAKE_BINARY_DIR}/tests/mocks/
             ${CMAKE_SOURCE_DIR}/src
             ${CMAKE_CURRENT_SOURCE_DIR}/wifi
             ${qmltest_DEFAULT_IMPORT_PATHS})

set(SYSTEMUPDATE_IMPORT_PATHS
    ${CMAKE_SOURCE_DIR}/src
    ${CMAKE_BINARY_DIR}/tests/utils/modules
    ${CMAKE_BINARY_DIR}/tests/mocks/
    ${CMAKE_SOURCE_DIR}/tests/plugins/system-update
)

add_qml_test(main MainWindow
    IMPORT_PATHS
    ${CMAKE_BINARY_DIR}/tests/mocks/
    ${CMAKE_SOURCE_DIR}/tests/plugins/main
    ${qmltest_DEFAULT_IMPORT_PATHS}
)

set(LAUNCHER_IMPORT_PATHS
    ${CMAKE_BINARY_DIR}/tests/mocks/
    ${CMAKE_SOURCE_DIR}/tests/plugins/launcher
    ${qmltest_DEFAULT_IMPORT_PATHS}
)
add_qml_test(launcher LauncherPageComponent IMPORT_PATHS ${LAUNCHER_IMPORT_PATHS})

=== plugins/background/Theme/CMakeLists.txt ===
add_library(LomiriThemeSettings MODULE
plugin.cpp theme.cpp plugin.h theme.h)

target_link_libraries(LomiriThemeSettings Qt5::Qml Qt5::Quick)

set(PLUG_DIR ${PLUGIN_PRIVATE_MODULE_DIR}/Lomiri/SystemSettings/Background/Theme)
install(TARGETS LomiriThemeSettings DESTINATION ${PLUG_DIR})
install(FILES qmldir DESTINATION ${PLUG_DIR})

=== debian/changelog ===
lomiri-system-settings (1.3.1-6) unstable; urgency=medium

  * debian/rules:
    + Set correct lomiri-keyboard plugin-path at build-time.

 -- Mike Gabriel <sunweaver@debian.org>  Mon, 23 Jun 2025 13:23:09 +0200

lomiri-system-settings (1.3.1-5) unstable; urgency=medium

  * debian/patches:
    + Replace 0001_lib-LomiriSystemSettingsPrivate-accountsservice.cpp-Register-
      missing-D-Bus-types.patch by 0001_plugins-language-hardwarekeyboard-
      plugin.cpp-Registe.patch (reviewed upstream patch).
    + Add 0002_Add-shortcut-to-OSK-layout-settings.patch. Make OSK layout
      settings available via URL dispatcher call.

 -- Mike Gabriel <sunweaver@debian.org>  Sun, 22 Jun 2025 22:16:23 +0200

lomiri-system-settings (1.3.1-4) unstable; urgency=medium

  * debian/patches:
    + Add 0001_lib-LomiriSystemSettingsPrivate-accountsservice.cpp-Register-
      missing-D-Bus-types.patch. lib/LomiriSystemSettingsPrivate/
      accountsservice.cpp: Register missing D-Bus types. This resolves
      l-s-s crashes when the external keyboard selector interacts with
      ayatana-indicator-keyboard via AccountsService.

 -- Mike Gabriel <sunweaver@debian.org>  Sat, 14 Jun 2025 07:54:49 +0200

lomiri-system-settings (1.3.1-3) unstable; urgency=medium

  [ Adam Havelka ]
  * debian/patches:
    + Add 2014_removing-unnecessary-mobile-only-functionality.patch. Make
      About plugin available on mainline Linux (i.e. Debian) by removing
      mobile-only / Ubuntu Touch / libhybris / deviceinfo functionality and
      information.

 -- Mike Gabriel <sunweaver@debian.org>  Fri, 06 Jun 2025 23:13:52 +0200

lomiri-system-settings (1.3.1-2) unstable; urgency=medium

  * debian/patches:
    + Update 2011_build-without-trust-store.patch. Fix regression introduced in
      lomiri-system-settings 1.3.1-1.

 -- Mike Gabriel <sunweaver@debian.org>  Sun, 04 May 2025 08:40:32 +0200

lomiri-system-settings (1.3.1-1) unstable; urgency=medium

  * New upstream release.
  * debian/patches:
    + Drop 1001_dont-hardcode-cxx-standard.patch. Applied upstream.
    + Rebase 2002_use-Noto-font-instead-of-Ubuntu-font.patch.
    + Drop 2012_no-Location-service-yet.patch. Location service is now available
      in Debian.
    + Add 2013_show-hotspot-on-desktop.patch. Show hotspot feature for all
      form-factors.
  * debian/control:
    + Add to R: lomiri-location-service-bin.
  * debian/copyright:
    + Update auto-generated copyright.in file.
    + Update copyright attributions.

 -- Mike Gabriel <sunweaver@debian.org>  Fri, 02 May 2025 11:12:16 +0200

## lomiri-system-settings 1.3.2

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,6 +1,6 @@
 cmake_minimum_required(VERSION 3.5)
 
-project(lomiri-system-settings VERSION 1.3.1 LANGUAGES C CXX)
+project(lomiri-system-settings VERSION 1.3.2 LANGUAGES C CXX)
 
 if(${PROJECT_BINARY_DIR} STREQUAL ${PROJECT_SOURCE_DIR})
    message(FATAL_ERROR "In-tree build attempt detected, aborting. Set your build dir outside your source dir, delete CMakeCache.txt from source root and try again.")

=== plugins/CMakeLists.txt ===
if(ANDR_PROP_FOUND)
    add_subdirectory(about)
    add_subdirectory(brightness)
    add_subdirectory(nfc)
endif()
add_subdirectory(background)
add_subdirectory(battery)
add_subdirectory(bluetooth)
add_subdirectory(example)
add_subdirectory(flight-mode)
add_subdirectory(gestures)
add_subdirectory(hotspot)
add_subdirectory(language)
add_subdirectory(launcher)
add_subdirectory(mouse)
add_subdirectory(notifications)
add_subdirectory(orientation-lock)
add_subdirectory(printing)
add_subdirectory(reset)
add_subdirectory(security-privacy)
add_subdirectory(sound)
add_subdirectory(time-date)
add_subdirectory(usb)
add_subdirectory(vpn)
add_subdirectory(wifi)

=== po/CMakeLists.txt ===
include(FindGettext)

find_program(GETTEXT_XGETTEXT_EXECUTABLE xgettext)
if("${GETTEXT_XGETTEXT_EXECUTABLE}" STREQUAL "GETTEXT_XGETTEXT_EXECUTABLE-NOTFOUND")
    message(FATAL_ERROR "Could not find xgettext")
endif()
find_package(Python3 COMPONENTS Interpreter)
if(NOT Python3_FOUND)
    message(FATAL_ERROR "python3 not found")
endif()

set(DOMAIN ${PROJECT_NAME})
set(POT_FILE ${DOMAIN}.pot)

file(STRINGS ${CMAKE_CURRENT_SOURCE_DIR}/LINGUAS LINGUAS
     REGEX "^[^#].*")
string(REGEX MATCHALL "[^ \t]+" LANGS "${LINGUAS}")

configure_file(${CMAKE_CURRENT_SOURCE_DIR}/POTFILES.in
               ${CMAKE_CURRENT_BINARY_DIR}/POTFILES COPYONLY)

file(GLOB SETTINGSFILES "${CMAKE_SOURCE_DIR}/plugins/*/*.settings")
set(SETTINGSJSFILE "plugin-strings.generated.js")

add_custom_target(${POT_FILE} ALL
                  DEPENDS ${SETTINGSFILES}
                  COMMENT "Generating translation template"
                  COMMAND ${Python3_EXECUTABLE}
                          ${CMAKE_CURRENT_SOURCE_DIR}/extractsettingsinfo
                          ${SETTINGSFILES}
                          -o ${CMAKE_CURRENT_BINARY_DIR}/${SETTINGSJSFILE}
                  COMMAND ${GETTEXT_XGETTEXT_EXECUTABLE} -o ${POT_FILE}
                          --from-code=UTF-8
                          --language=Desktop
                          --package-name='${PROJECT_NAME}'
                          --copyright-holder='Canonical Ltd.'
                          --keyword --keyword=Name --keyword=Keywords
                          -D ${CMAKE_BINARY_DIR}
                          ${DESKTOP_FILE}.in
                  COMMAND ${GETTEXT_XGETTEXT_EXECUTABLE} -o ${POT_FILE}
                          -D ${CMAKE_SOURCE_DIR}
                          -D ${CMAKE_CURRENT_SOURCE_DIR}
                          -D ${CMAKE_CURRENT_BINARY_DIR}
                          --from-code=UTF-8
                          --c++
                          --qt
                          --add-comments=TRANSLATORS
                          --keyword=_ --keyword=tr --keyword=tr:1,2
                          --package-name='${PROJECT_NAME}'
                          --copyright-holder='Canonical Ltd.'
                          --join-existing
                          --files-from=${CMAKE_CURRENT_BINARY_DIR}/POTFILES
                          ${SETTINGSJSFILE})

foreach(LANG ${LANGS})
    configure_file(${CMAKE_CURRENT_SOURCE_DIR}/${LANG}.po
                   ${CMAKE_CURRENT_BINARY_DIR}/${LANG}.po
                   COPYONLY)
endforeach(LANG)
gettext_process_pot_file(${POT_FILE} ALL
                         INSTALL_DESTINATION ${CMAKE_INSTALL_LOCALEDIR}
                         LANGUAGES ${LANGS})

=== schema/CMakeLists.txt ===
install(FILES com.lomiri.lomiri-system-settings.gschema.xml DESTINATION "${CMAKE_INSTALL_DATADIR}/glib-2.0/schemas")

=== src/CMakeLists.txt ===
include_directories(${GLIB_INCLUDE_DIRS})

add_definitions(-DI18N_DIRECTORY="${CMAKE_INSTALL_FULL_LOCALEDIR}")
add_definitions(-DI18N_DOMAIN="lomiri-system-settings")
add_definitions(-DPLUGIN_PRIVATE_MODULE_DIR="${PLUGIN_PRIVATE_MODULE_DIR}")
add_definitions(-DMANIFEST_DIR="${MANIFEST_DIR}")
add_definitions(-DPLUGIN_MANIFEST_DIR="${PLUGIN_MANIFEST_DIR}")
add_definitions(-DQML_DIR="${QML_DIR}")
add_definitions(-DPLUGIN_QML_DIR="${PLUGIN_QML_DIR}")
add_definitions(-DPLUGIN_MODULE_DIR="${PLUGIN_MODULE_DIR}")

add_subdirectory(SystemSettings)

set(USS_SOURCES
    debug.cpp
    item-model.cpp
    main.cpp
    plugin-manager.cpp
    plugin.cpp
    utils.cpp
)

set(QML_SOURCES
    qml/AdaptiveContainer.qml
    qml/CategorySection.qml
    qml/EntryComponent.qml
    qml/EntryComponentGrid.qml
    qml/EntryComponentList.qml
    qml/MainWindow.qml
    qml/UncategorizedItemsView.qml
    SystemSettings/ItemPage.qml
    SystemSettings/SettingsItemTitle.qml
)

QT5_ADD_RESOURCES(system-settings-resources ui.qrc)

add_executable(lomiri-system-settings ${USS_SOURCES} ${QML_SOURCES} ${system-settings-resources})
target_link_libraries(lomiri-system-settings Qt5::Core Qt5::Gui Qt5::Quick Qt5::Qml Qt5::DBus Qt5::Widgets LomiriSystemSettings LomiriSystemSettingsPrivate ${GLIB_LDFLAGS})
install(TARGETS lomiri-system-settings RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR})

install(FILES ${CMAKE_CURRENT_SOURCE_DIR}/url-map.ini DESTINATION ${PLUGIN_MANIFEST_DIR})

=== lib/LomiriSystemSettings/CMakeLists.txt ===
--- 
+++ 
@@ -1,6 +1,6 @@
 add_library(LomiriSystemSettings SHARED item-base.cpp item-base.h)
 set_target_properties(LomiriSystemSettings PROPERTIES
-VERSION 1.3.1
+VERSION 1.3.2
 SOVERSION 1
 )

=== lib/LomiriSystemSettingsPrivate/CMakeLists.txt ===
set(HEADERS
    accountsservice.h
    i18n.h
    systemimage.h
)
set(SOURCES
    accountsservice.cpp
    i18n.cpp
    systemimage.cpp
)

add_library(LomiriSystemSettingsPrivate SHARED ${HEADERS} ${SOURCES})
set_target_properties(LomiriSystemSettingsPrivate PROPERTIES
VERSION 0.0
SOVERSION 0.0
)

target_link_libraries(LomiriSystemSettingsPrivate Qt5::Core Qt5::DBus)

# Makes the life easier for in-tree plugins
target_include_directories(LomiriSystemSettingsPrivate PUBLIC
    ${CMAKE_CURRENT_SOURCE_DIR}
)

install(TARGETS LomiriSystemSettingsPrivate LIBRARY DESTINATION ${LIBDIR})
install(FILES ${HEADERS}
        DESTINATION "${CMAKE_INSTALL_INCLUDEDIR}/LomiriSystemSettings/private")

=== plugins/background/CMakeLists.txt ===
add_subdirectory(Components)
add_subdirectory(Theme)

set(QML_SOURCES
    MainPage.qml
    WallpaperGrid.qml
    Preview.qml
    utilities.js
)
add_library(LomiriBackgroundPanel MODULE
plugin.cpp background.cpp plugin.h background.h
${QML_SOURCES}) # So they show up in Qt designer.
target_include_directories (LomiriBackgroundPanel PUBLIC ${GIO_INCLUDE_DIRS})
target_link_libraries (LomiriBackgroundPanel ${GIO_LDFLAGS} Qt5::Qml Qt5::Quick Qt5::DBus LomiriSystemSettingsPrivate)

set(PLUG_DIR ${PLUGIN_PRIVATE_MODULE_DIR}/Lomiri/SystemSettings/Background)
install(TARGETS LomiriBackgroundPanel DESTINATION ${PLUG_DIR})
install(FILES qmldir DESTINATION ${PLUG_DIR})
install(FILES ${QML_SOURCES} DESTINATION ${PLUGIN_QML_DIR}/background)
install(FILES welcomeoverlay.svg import-image@18.png header_handlearrow.png header_handlearrow2.png bullet.png
        DESTINATION ${PLUGIN_QML_DIR}/background)
install(FILES settings-background.svg DESTINATION ${PLUGIN_MANIFEST_DIR}/icons)
install(FILES background.settings DESTINATION ${PLUGIN_MANIFEST_DIR})

=== plugins/bluetooth/CMakeLists.txt ===
include_directories(${CMAKE_CURRENT_BINARY_DIR})

set(QML_SOURCES
ProvidePinCodeDialog.qml
ConfirmPasskeyDialog.qml
DisplayPinCodeDialog.qml
DisplayPasskeyDialog.qml
ProvidePasskeyDialog.qml
AuthorizationRequestDialog.qml
DevicePage.qml
PageComponent.qml
)

add_library(LomiriBluetoothPanel MODULE
  bluez_adapter1.cpp
  bluez_agentmanager1.cpp
  bluez_device1.cpp
  bluez_agent1adaptor.cpp
  freedesktop_properties.cpp
  freedesktop_objectmanager.cpp
  agent.cpp
  bluetooth.cpp
  device.cpp
  devicemodel.cpp
  bluez_adapter1.h
  bluez_agentmanager1.h
  bluez_device1.h
  bluez_agent1adaptor.h
  freedesktop_properties.h
  freedesktop_objectmanager.h
  plugin.cpp
  bluez_helper.h
  agent.h
  bluetooth.h
  device.h
  devicemodel.h
  plugin.h
  ${QML_SOURCES}
)

target_link_libraries(LomiriBluetoothPanel Qt5::Qml Qt5::Quick Qt5::DBus)

set(PLUG_DIR ${PLUGIN_PRIVATE_MODULE_DIR}/Lomiri/SystemSettings/Bluetooth)
install(TARGETS LomiriBluetoothPanel DESTINATION ${PLUG_DIR})
install(FILES qmldir DESTINATION ${PLUG_DIR})
install(FILES ${QML_SOURCES} DESTINATION ${PLUGIN_QML_DIR}/bluetooth)

install(FILES bluetooth.settings DESTINATION ${PLUGIN_MANIFEST_DIR})
install(FILES settings-bluetooth.svg DESTINATION ${PLUGIN_MANIFEST_DIR}/icons)

=== plugins/brightness/CMakeLists.txt ===
include_directories(${ANDR_PROP_INCLUDE_DIRS})
add_subdirectory(plugin)

set(QML_SOURCES
    PageComponent.qml
    WifiDisplays.qml
    WifiDisplaysAlert.qml
)

add_library(LomiriBrightnessPanel MODULE
                aethercast/aethercast_helper.h
                aethercast/aethercast_device.h
                aethercast/aethercast_manager.h
                aethercast/device.h
                aethercast/devicemodel.h
                aethercast/displays.h
                aethercast/freedesktop_properties.h
                aethercast/freedesktop_objectmanager.h
                plugin.h
                brightness.h
                aethercast/aethercast_device.cpp
	        aethercast/aethercast_manager.cpp
	        aethercast/device.cpp
	        aethercast/devicemodel.cpp
                aethercast/displays.cpp
	        aethercast/freedesktop_properties.cpp
	        aethercast/freedesktop_objectmanager.cpp
                plugin.cpp
                brightness.cpp
                ${QML_SOURCES})
target_link_libraries(LomiriBrightnessPanel Qt5::Quick Qt5::Qml Qt5::DBus LomiriSystemSettings ${ANDR_PROP_LDFLAGS})

set(PLUG_DIR ${PLUGIN_PRIVATE_MODULE_DIR}/Lomiri/SystemSettings/Brightness)
install(TARGETS LomiriBrightnessPanel DESTINATION ${PLUG_DIR})
install(FILES qmldir DESTINATION ${PLUG_DIR})
install(FILES brightness.settings DESTINATION ${PLUGIN_MANIFEST_DIR})
install(FILES settings-brightness.svg DESTINATION ${PLUGIN_MANIFEST_DIR}/icons)
install(FILES ${QML_SOURCES} DESTINATION ${PLUGIN_QML_DIR}/brightness)

=== plugins/gestures/CMakeLists.txt ===
set(QML_SOURCES PageComponent.qml)

add_library(LomiriGesturesPanel MODULE
  gestures_dbushelper.cpp
  gestures_dbushelper.h
  plugin.cpp
  plugin.h
  ${QML_SOURCES}
)
target_link_libraries(LomiriGesturesPanel Qt5::Qml Qt5::Quick Qt5::DBus)

set(PLUG_DIR ${PLUGIN_PRIVATE_MODULE_DIR}/Lomiri/SystemSettings/Gestures)
install(TARGETS LomiriGesturesPanel DESTINATION ${PLUG_DIR})
install(FILES qmldir.in DESTINATION ${PLUG_DIR} RENAME qmldir)
install(FILES gestures.settings DESTINATION ${PLUGIN_MANIFEST_DIR})
install(FILES ${QML_SOURCES} DESTINATION ${PLUGIN_QML_DIR}/gestures)

=== plugins/hotspot/CMakeLists.txt ===
add_subdirectory(plugin)

set(QML_SOURCES
    HotspotSetup.qml
    PageComponent.qml
)

# We need a dummy target so the QML files show up in Qt Creator
# If this plugin gets some C++ sources, remove this.
add_custom_target(hotspot-holder
COMMAND echo This is just a dummy.
SOURCES ${QML_SOURCES})

set(PLUG_DIR ${PLUGIN_PRIVATE_MODULE_DIR}/Lomiri/SystemSettings/Hotspot)

install(FILES qmldir DESTINATION ${PLUG_DIR})
install(FILES hotspot.settings DESTINATION ${PLUGIN_MANIFEST_DIR})
install(FILES settings-hotspot.svg DESTINATION ${PLUGIN_MANIFEST_DIR}/icons)
install(FILES ${QML_SOURCES} DESTINATION ${PLUGIN_QML_DIR}/hotspot)

=== debian/changelog ===
lomiri-system-settings (1.3.2-1) unstable; urgency=medium

  * New upstream release.
  * debian/patches:
    + Rebase 2014_removing-unnecessary-mobile-only-functionality.patch.

 -- Mike Gabriel <sunweaver@debian.org>  Tue, 12 Aug 2025 11:43:36 +0200

=== debian/control ===
Source: lomiri-system-settings
Section: misc
Priority: optional
Maintainer: Debian UBports Team <team+ubports@tracker.debian.org>
Uploaders:
 Marius Gripsgard <marius@ubports.com>,
 Mike Gabriel <sunweaver@debian.org>,
Build-Depends: cmake,
               cmake-extras,
               dbus-test-runner,
               debhelper-compat (= 13),
               gir1.2-glib-2.0 <!nocheck>,
               intltool,
               libaccountsservice-dev,
               libapt-pkg-dev,
               libclick-dev,
               libdeviceinfo-dev,
               libevdev-dev,
               libgeonames-dev,
               libglib2.0-dev (>= 2.37.92),
               libgnome-desktop-3-dev,
               libgsettings-qt-dev,
               libicu-dev,
               libpolkit-agent-1-dev,
               libqmenumodel-dev,
               libqt5sql5-sqlite <!nocheck>,
               libqtdbusmock1-dev (>= 0.2+14.04.20140724) <!nocheck>,
               libqtdbustest1-dev <!nocheck>,
               libsystemd-dev,
               libudev-dev,
               libupower-glib-dev,
               pkgconf,
               qml-module-lomiri-components <!nocheck>,
               qml-module-lomiri-settings-components <!nocheck>,
               qml-module-lomiri-settings-fingerprint <!nocheck>,
               qml-module-lomiri-settings-menus <!nocheck>,
               qml-module-lomiri-settings-vpn <!nocheck>,
               qml-module-ofono (>=0.117~) <!nocheck>,
               qml-module-qtcontacts,
               qml-module-qtquick-layouts,
               qml-module-qtquick2 <!nocheck>,
               qml-module-qtsysteminfo (>= 5.0~),
               qml-module-qttest <!nocheck>,
               qtbase5-dev,
               qtbase5-private-dev <!nocheck>,
               qtdeclarative5-dev,
               qtdeclarative5-dev-tools,
               suru-icon-theme,
               xvfb <!nocheck>,
               xauth <!nocheck>,
Standards-Version: 4.7.0
Rules-Requires-Root: no
Homepage: https://gitlab.com/ubports/development/core/lomiri-system-settings
Vcs-Git: https://salsa.debian.org/ubports-team/lomiri-system-settings.git
Vcs-Browser: https://salsa.debian.org/ubports-team/lomiri-system-settings

Package: lomiri-system-settings
Architecture: any
Depends: accountsservice,
         bluez (>= 5.23),
         click | ubuntu-snappy-cli,
         gir1.2-glib-2.0,
         gsettings-desktop-schemas,
         fonts-noto-core,
         liblomirisystemsettings1 (= ${binary:Version}),
         lomiri-indicator-network,
         lomiri-schemas (>= 0.1.5),
         python3,
         python3-gi,
         lomiri-keyboard,
         qmenumodel-qml,
         qml-module-gsettings1.0,
         qml-module-lomiri-components,
         qml-module-lomiri-components-extras,
         qml-module-lomiri-connectivity (>= 0.7.1),
         qml-module-lomiri-content,
         qml-module-lomiri-settings-components,
         qml-module-lomiri-settings-fingerprint,
         qml-module-lomiri-settings-menus,
         qml-module-lomiri-settings-vpn,
         qml-module-ofono (>=0.117~),
         qml-module-qt-labs-folderlistmodel,
         qml-module-qtmultimedia | qml-module-qtmultimedia-gles,
         qml-module-qtsysteminfo,
         suru-icon-theme (>= 14.04+15.04.20150813~),
         lomiri-wallpapers,
         upower,
         ${misc:Depends},
         ${shlibs:Depends},
Suggests: aethercast,
          dbus-property-service,
          system-image-dbus (>= 3.1),
          urfkill,
Recommends: lomiri (>= 0.3.0-1~),
            lomiri-sounds,
            lomiri-system-settings-online-accounts,
            lomiri-location-service-bin,
            repowerd,
Breaks: lomiri-system-settings-security-privacy,
Replaces: lomiri-system-settings-security-privacy,
Provides: lomiri-system-settings-security-privacy,
Description: System Settings application for Lomiri
 Lomiri-system-settings is the System Settings application used in Lomiri
 operating environment. it's designed for phones, tablets and convergent
 devices.

Package: liblomirisystemsettings1
Section: libs
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends},
         ${shlibs:Depends},
Description: System Settings application for Lomiri - plug-in library
 Lomiri-system-settings is the System Settings application used in Lomiri
 operating environment. it's designed for phones, tablets and convergent
 devices.
 .
 This package contains the library used by settings plugins.

Package: liblomirisystemsettings-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: liblomirisystemsettings1 (= ${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends},
Description: System Settings application for Lomiri - plug-in development files
 Lomiri-system-settings is the System Settings application used in Lomiri
 operating environment. it's designed for phones, tablets and convergent
 devices.
 .
 This package contains the plug-in library's development files.

Package: liblomirisystemsettingsprivate0.0
Section: libs
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends},
         ${shlibs:Depends},
Description: System Settings application for Lomiri - private library
 Lomiri-system-settings is the System Settings application used in Lomiri
 operating environment. it's designed for phones, tablets and convergent
 devices.
 .
 This package contains the private library used by some settings plugins.

Package: liblomirisystemsettingsprivate-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: liblomirisystemsettingsprivate0.0 (= ${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends},
Description: System Settings application for Lomiri - private development files
 Lomiri-system-settings is the System Settings application used in Lomiri
 operating environment. it's designed for phones, tablets and convergent
 devices.
 .
 This package contains the private library's development files.

#Package: lomiri-system-settings-autopilot
#Architecture: all
#Depends: dpkg-dev,
#         gir1.2-upowerglib-1.0,
#         libautopilot-qt,
#         lomiri-system-settings,
#         lomiri-ui-toolkit-autopilot,
#         python3-autopilot,
#         python3-dateutil,
#         python3-dbusmock (>= 0.14),
#         python3-evdev,
#         ${misc:Depends},
#         ${python3:Depends}
#Description: System Settings application for Lomiri - Autopilot tests
# Lomiri-system-settings is the System Settings application used in Lomiri
# operating environment. it's designed for phones, tablets and convergent
# devices.
# .
# This package contains the autopilot tests for lomiri-system-settings.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
export QT_SELECT=qt5

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

include /usr/share/dpkg/buildflags.mk
include /usr/share/dpkg/architecture.mk

testskip_architectures := powerpc

ifneq ($(DEB_BUILD_GNU_TYPE),$(DEB_HOST_GNU_TYPE))
export DEB_BUILD_PROFILES := cross
endif

ifneq (,$(findstring nocheck,$(DEB_BUILD_OPTIONS)))
export CONFIGURE_FLAGS := -DENABLE_TESTS=OFF
endif

ifeq ($(shell dpkg-vendor --derives-from Ubuntu && echo yes),yes)
CONFIGURE_FLAGS += -DENABLE_UBUNTU_ACCOUNTSSERVICE=ON
endif

export BUILDHOME=$(CURDIR)/debian/build

override_dh_auto_configure:
	# Debian defines CMAKE_INSTALL_LOCALSTATEDIR as /usr/var, which is wrong.
	# So until Debian bug 719148 is fixed, do it ourselves.
	dh_auto_configure -- -DCMAKE_INSTALL_LOCALSTATEDIR="/var"				\
	                     -DLOMIRI_KEYBOARD_PLUGIN_PATH="/usr/lib/lomiri-keyboard/plugins"	\
	                     -DMODERN_PYTHON_DBUSMOCK=ON					\
	                     -DENABLE_LIBDEVICEINFO=ON						\
	                     $(CONFIGURE_FLAGS)

override_dh_auto_build:
	dh_auto_build --parallel

override_dh_auto_clean:
	dh_auto_clean
	rm -rf $(BUILDHOME)

override_dh_auto_test:
	mkdir -p $(BUILDHOME)
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
ifneq (,$(filter $(DEB_HOST_ARCH),$(testskip_architectures)))
	export HOME=$(BUILDHOME) && -dh_auto_test --no-parallel
else
	export HOME=$(BUILDHOME) && dh_auto_test --no-parallel
endif
endif

override_dh_install:
#	cd tests/autopilot; \
#	set -ex; for python in $(shell py3versions -r); do \
#		$$python setup.py install --root=$(CURDIR)/debian/tmp --install-layout=deb; \
#	done; \
#	cd $(CURDIR)
	dh_install -X'*.pyc'

override_dh_makeshlibs:
	dh_makeshlibs -Xusr/lib/$(DEB_HOST_MULTIARCH)/lomiri-system-settings

override_dh_missing:
	dh_missing --fail-missing

%:
	dh $@

get-orig-source:
	uscan --noconf --force-download --rename --download-current-version --destdir=..
